<?php
namespace Amasty\Orderattr\Model\ResourceModel\Order\Attribute\Collection;

/**
 * Interceptor class for @see \Amasty\Orderattr\Model\ResourceModel\Order\Attribute\Collection
 */
class Interceptor extends \Amasty\Orderattr\Model\ResourceModel\Order\Attribute\Collection implements \Magento\Framework\Interception\InterceptorInterface
{
    use \Magento\Framework\Interception\Interceptor;

    public function __construct(\Magento\Framework\Data\Collection\EntityFactory $entityFactory, \Psr\Log\LoggerInterface $logger, \Magento\Framework\Data\Collection\Db\FetchStrategyInterface $fetchStrategy, \Magento\Framework\Event\ManagerInterface $eventManager, \Magento\Eav\Model\Config $eavConfig, \Magento\Eav\Model\EntityFactory $eavEntityFactory, \Magento\Framework\DB\Adapter\AdapterInterface $connection = null, \Magento\Framework\Model\ResourceModel\Db\AbstractDb $resource = null)
    {
        $this->___init();
        parent::__construct($entityFactory, $logger, $fetchStrategy, $eventManager, $eavConfig, $eavEntityFactory, $connection, $resource);
    }

    /**
     * {@inheritdoc}
     */
    public function getOrderAttributeTable()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getOrderAttributeTable');
        if (!$pluginInfo) {
            return parent::getOrderAttributeTable();
        } else {
            return $this->___callPlugins('getOrderAttributeTable', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addIsFilterableFilter()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addIsFilterableFilter');
        if (!$pluginInfo) {
            return parent::addIsFilterableFilter();
        } else {
            return $this->___callPlugins('addIsFilterableFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addStoreFilter($storeId)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addStoreFilter');
        if (!$pluginInfo) {
            return parent::addStoreFilter($storeId);
        } else {
            return $this->___callPlugins('addStoreFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addCustomerGroupFilter($groupId)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addCustomerGroupFilter');
        if (!$pluginInfo) {
            return parent::addCustomerGroupFilter($groupId);
        } else {
            return $this->___callPlugins('addCustomerGroupFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setEntityTypeFilter($typeId)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setEntityTypeFilter');
        if (!$pluginInfo) {
            return parent::setEntityTypeFilter($typeId);
        } else {
            return $this->___callPlugins('setEntityTypeFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function removePriceFilter()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'removePriceFilter');
        if (!$pluginInfo) {
            return parent::removePriceFilter();
        } else {
            return $this->___callPlugins('removePriceFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addDisplayInAdvancedSearchFilter()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addDisplayInAdvancedSearchFilter');
        if (!$pluginInfo) {
            return parent::addDisplayInAdvancedSearchFilter();
        } else {
            return $this->___callPlugins('addDisplayInAdvancedSearchFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addIsFilterableInSearchFilter()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addIsFilterableInSearchFilter');
        if (!$pluginInfo) {
            return parent::addIsFilterableInSearchFilter();
        } else {
            return $this->___callPlugins('addIsFilterableInSearchFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addVisibleFilter()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addVisibleFilter');
        if (!$pluginInfo) {
            return parent::addVisibleFilter();
        } else {
            return $this->___callPlugins('addVisibleFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addIsSearchableFilter()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addIsSearchableFilter');
        if (!$pluginInfo) {
            return parent::addIsSearchableFilter();
        } else {
            return $this->___callPlugins('addIsSearchableFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addToIndexFilter($addRequiredCodes = false)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addToIndexFilter');
        if (!$pluginInfo) {
            return parent::addToIndexFilter($addRequiredCodes);
        } else {
            return $this->___callPlugins('addToIndexFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addSearchableAttributeFilter()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addSearchableAttributeFilter');
        if (!$pluginInfo) {
            return parent::addSearchableAttributeFilter();
        } else {
            return $this->___callPlugins('addSearchableAttributeFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addIsUsedInGridFilter()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addIsUsedInGridFilter');
        if (!$pluginInfo) {
            return parent::addIsUsedInGridFilter();
        } else {
            return $this->___callPlugins('addIsUsedInGridFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function useLoadDataFields()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'useLoadDataFields');
        if (!$pluginInfo) {
            return parent::useLoadDataFields();
        } else {
            return $this->___callPlugins('useLoadDataFields', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setAttributeSetFilter($setId)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setAttributeSetFilter');
        if (!$pluginInfo) {
            return parent::setAttributeSetFilter($setId);
        } else {
            return $this->___callPlugins('setAttributeSetFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setAttributeSetFilterBySetName($attributeSetName, $entityTypeCode)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setAttributeSetFilterBySetName');
        if (!$pluginInfo) {
            return parent::setAttributeSetFilterBySetName($attributeSetName, $entityTypeCode);
        } else {
            return $this->___callPlugins('setAttributeSetFilterBySetName', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setAttributeSetsFilter(array $setIds)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setAttributeSetsFilter');
        if (!$pluginInfo) {
            return parent::setAttributeSetsFilter($setIds);
        } else {
            return $this->___callPlugins('setAttributeSetsFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setInAllAttributeSetsFilter(array $setIds)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setInAllAttributeSetsFilter');
        if (!$pluginInfo) {
            return parent::setInAllAttributeSetsFilter($setIds);
        } else {
            return $this->___callPlugins('setInAllAttributeSetsFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setAttributesExcludeFilter($attributes)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setAttributesExcludeFilter');
        if (!$pluginInfo) {
            return parent::setAttributesExcludeFilter($attributes);
        } else {
            return $this->___callPlugins('setAttributesExcludeFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setExcludeSetFilter($setId)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setExcludeSetFilter');
        if (!$pluginInfo) {
            return parent::setExcludeSetFilter($setId);
        } else {
            return $this->___callPlugins('setExcludeSetFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setAttributeGroupFilter($groupId)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setAttributeGroupFilter');
        if (!$pluginInfo) {
            return parent::setAttributeGroupFilter($groupId);
        } else {
            return $this->___callPlugins('setAttributeGroupFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addAttributeGrouping()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addAttributeGrouping');
        if (!$pluginInfo) {
            return parent::addAttributeGrouping();
        } else {
            return $this->___callPlugins('addAttributeGrouping', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addIsUniqueFilter()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addIsUniqueFilter');
        if (!$pluginInfo) {
            return parent::addIsUniqueFilter();
        } else {
            return $this->___callPlugins('addIsUniqueFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addIsNotUniqueFilter()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addIsNotUniqueFilter');
        if (!$pluginInfo) {
            return parent::addIsNotUniqueFilter();
        } else {
            return $this->___callPlugins('addIsNotUniqueFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addHasOptionsFilter()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addHasOptionsFilter');
        if (!$pluginInfo) {
            return parent::addHasOptionsFilter();
        } else {
            return $this->___callPlugins('addHasOptionsFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setFrontendInputTypeFilter($frontendInputType)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setFrontendInputTypeFilter');
        if (!$pluginInfo) {
            return parent::setFrontendInputTypeFilter($frontendInputType);
        } else {
            return $this->___callPlugins('setFrontendInputTypeFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addSetInfo($flag = true)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addSetInfo');
        if (!$pluginInfo) {
            return parent::addSetInfo($flag);
        } else {
            return $this->___callPlugins('addSetInfo', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setCodeFilter($code)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setCodeFilter');
        if (!$pluginInfo) {
            return parent::setCodeFilter($code);
        } else {
            return $this->___callPlugins('setCodeFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addStoreLabel($storeId)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addStoreLabel');
        if (!$pluginInfo) {
            return parent::addStoreLabel($storeId);
        } else {
            return $this->___callPlugins('addStoreLabel', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getSelectCountSql()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getSelectCountSql');
        if (!$pluginInfo) {
            return parent::getSelectCountSql();
        } else {
            return $this->___callPlugins('getSelectCountSql', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function joinLeft($table, $cond, $cols = '*')
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'joinLeft');
        if (!$pluginInfo) {
            return parent::joinLeft($table, $cond, $cols);
        } else {
            return $this->___callPlugins('joinLeft', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getMainTable()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getMainTable');
        if (!$pluginInfo) {
            return parent::getMainTable();
        } else {
            return $this->___callPlugins('getMainTable', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setMainTable($table)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setMainTable');
        if (!$pluginInfo) {
            return parent::setMainTable($table);
        } else {
            return $this->___callPlugins('setMainTable', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getSelect()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getSelect');
        if (!$pluginInfo) {
            return parent::getSelect();
        } else {
            return $this->___callPlugins('getSelect', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addFieldToSelect($field, $alias = null)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addFieldToSelect');
        if (!$pluginInfo) {
            return parent::addFieldToSelect($field, $alias);
        } else {
            return $this->___callPlugins('addFieldToSelect', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addExpressionFieldToSelect($alias, $expression, $fields)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addExpressionFieldToSelect');
        if (!$pluginInfo) {
            return parent::addExpressionFieldToSelect($alias, $expression, $fields);
        } else {
            return $this->___callPlugins('addExpressionFieldToSelect', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function removeFieldFromSelect($field, $isAlias = false)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'removeFieldFromSelect');
        if (!$pluginInfo) {
            return parent::removeFieldFromSelect($field, $isAlias);
        } else {
            return $this->___callPlugins('removeFieldFromSelect', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function removeAllFieldsFromSelect()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'removeAllFieldsFromSelect');
        if (!$pluginInfo) {
            return parent::removeAllFieldsFromSelect();
        } else {
            return $this->___callPlugins('removeAllFieldsFromSelect', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setModel($model)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setModel');
        if (!$pluginInfo) {
            return parent::setModel($model);
        } else {
            return $this->___callPlugins('setModel', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getModelName()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getModelName');
        if (!$pluginInfo) {
            return parent::getModelName();
        } else {
            return $this->___callPlugins('getModelName', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setResourceModel($model)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setResourceModel');
        if (!$pluginInfo) {
            return parent::setResourceModel($model);
        } else {
            return $this->___callPlugins('setResourceModel', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getResourceModelName()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getResourceModelName');
        if (!$pluginInfo) {
            return parent::getResourceModelName();
        } else {
            return $this->___callPlugins('getResourceModelName', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getResource()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getResource');
        if (!$pluginInfo) {
            return parent::getResource();
        } else {
            return $this->___callPlugins('getResource', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getTable($table)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getTable');
        if (!$pluginInfo) {
            return parent::getTable($table);
        } else {
            return $this->___callPlugins('getTable', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getAllIds()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getAllIds');
        if (!$pluginInfo) {
            return parent::getAllIds();
        } else {
            return $this->___callPlugins('getAllIds', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function join($table, $cond, $cols = '*')
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'join');
        if (!$pluginInfo) {
            return parent::join($table, $cond, $cols);
        } else {
            return $this->___callPlugins('join', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setResetItemsDataChanged($flag)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setResetItemsDataChanged');
        if (!$pluginInfo) {
            return parent::setResetItemsDataChanged($flag);
        } else {
            return $this->___callPlugins('setResetItemsDataChanged', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function resetItemsDataChanged()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'resetItemsDataChanged');
        if (!$pluginInfo) {
            return parent::resetItemsDataChanged();
        } else {
            return $this->___callPlugins('resetItemsDataChanged', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function save()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'save');
        if (!$pluginInfo) {
            return parent::save();
        } else {
            return $this->___callPlugins('save', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addBindParam($name, $value)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addBindParam');
        if (!$pluginInfo) {
            return parent::addBindParam($name, $value);
        } else {
            return $this->___callPlugins('addBindParam', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getIdFieldName()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getIdFieldName');
        if (!$pluginInfo) {
            return parent::getIdFieldName();
        } else {
            return $this->___callPlugins('getIdFieldName', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setConnection(\Magento\Framework\DB\Adapter\AdapterInterface $conn)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setConnection');
        if (!$pluginInfo) {
            return parent::setConnection($conn);
        } else {
            return $this->___callPlugins('setConnection', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getConnection()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getConnection');
        if (!$pluginInfo) {
            return parent::getConnection();
        } else {
            return $this->___callPlugins('getConnection', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getSize()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getSize');
        if (!$pluginInfo) {
            return parent::getSize();
        } else {
            return $this->___callPlugins('getSize', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getSelectSql($stringMode = false)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getSelectSql');
        if (!$pluginInfo) {
            return parent::getSelectSql($stringMode);
        } else {
            return $this->___callPlugins('getSelectSql', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setOrder($field, $direction = 'DESC')
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setOrder');
        if (!$pluginInfo) {
            return parent::setOrder($field, $direction);
        } else {
            return $this->___callPlugins('setOrder', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addOrder($field, $direction = 'DESC')
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addOrder');
        if (!$pluginInfo) {
            return parent::addOrder($field, $direction);
        } else {
            return $this->___callPlugins('addOrder', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function unshiftOrder($field, $direction = 'DESC')
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'unshiftOrder');
        if (!$pluginInfo) {
            return parent::unshiftOrder($field, $direction);
        } else {
            return $this->___callPlugins('unshiftOrder', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addFieldToFilter($field, $condition = null)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addFieldToFilter');
        if (!$pluginInfo) {
            return parent::addFieldToFilter($field, $condition);
        } else {
            return $this->___callPlugins('addFieldToFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function distinct($flag)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'distinct');
        if (!$pluginInfo) {
            return parent::distinct($flag);
        } else {
            return $this->___callPlugins('distinct', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function load($printQuery = false, $logQuery = false)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'load');
        if (!$pluginInfo) {
            return parent::load($printQuery, $logQuery);
        } else {
            return $this->___callPlugins('load', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function loadWithFilter($printQuery = false, $logQuery = false)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'loadWithFilter');
        if (!$pluginInfo) {
            return parent::loadWithFilter($printQuery, $logQuery);
        } else {
            return $this->___callPlugins('loadWithFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function fetchItem()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'fetchItem');
        if (!$pluginInfo) {
            return parent::fetchItem();
        } else {
            return $this->___callPlugins('fetchItem', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getData()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getData');
        if (!$pluginInfo) {
            return parent::getData();
        } else {
            return $this->___callPlugins('getData', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function resetData()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'resetData');
        if (!$pluginInfo) {
            return parent::resetData();
        } else {
            return $this->___callPlugins('resetData', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function loadData($printQuery = false, $logQuery = false)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'loadData');
        if (!$pluginInfo) {
            return parent::loadData($printQuery, $logQuery);
        } else {
            return $this->___callPlugins('loadData', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function printLogQuery($printQuery = false, $logQuery = false, $sql = null)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'printLogQuery');
        if (!$pluginInfo) {
            return parent::printLogQuery($printQuery, $logQuery, $sql);
        } else {
            return $this->___callPlugins('printLogQuery', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addFilterToMap($filter, $alias, $group = 'fields')
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addFilterToMap');
        if (!$pluginInfo) {
            return parent::addFilterToMap($filter, $alias, $group);
        } else {
            return $this->___callPlugins('addFilterToMap', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function joinExtensionAttribute(\Magento\Framework\Api\ExtensionAttribute\JoinDataInterface $join, \Magento\Framework\Api\ExtensionAttribute\JoinProcessorInterface $extensionAttributesJoinProcessor)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'joinExtensionAttribute');
        if (!$pluginInfo) {
            return parent::joinExtensionAttribute($join, $extensionAttributesJoinProcessor);
        } else {
            return $this->___callPlugins('joinExtensionAttribute', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getItemObjectClass()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getItemObjectClass');
        if (!$pluginInfo) {
            return parent::getItemObjectClass();
        } else {
            return $this->___callPlugins('getItemObjectClass', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addFilter($field, $value, $type = 'and')
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addFilter');
        if (!$pluginInfo) {
            return parent::addFilter($field, $value, $type);
        } else {
            return $this->___callPlugins('addFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getFilter($field)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getFilter');
        if (!$pluginInfo) {
            return parent::getFilter($field);
        } else {
            return $this->___callPlugins('getFilter', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function isLoaded()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'isLoaded');
        if (!$pluginInfo) {
            return parent::isLoaded();
        } else {
            return $this->___callPlugins('isLoaded', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getCurPage($displacement = 0)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getCurPage');
        if (!$pluginInfo) {
            return parent::getCurPage($displacement);
        } else {
            return $this->___callPlugins('getCurPage', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getLastPageNumber()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getLastPageNumber');
        if (!$pluginInfo) {
            return parent::getLastPageNumber();
        } else {
            return $this->___callPlugins('getLastPageNumber', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getPageSize()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getPageSize');
        if (!$pluginInfo) {
            return parent::getPageSize();
        } else {
            return $this->___callPlugins('getPageSize', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getFirstItem()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getFirstItem');
        if (!$pluginInfo) {
            return parent::getFirstItem();
        } else {
            return $this->___callPlugins('getFirstItem', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getLastItem()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getLastItem');
        if (!$pluginInfo) {
            return parent::getLastItem();
        } else {
            return $this->___callPlugins('getLastItem', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getItems()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getItems');
        if (!$pluginInfo) {
            return parent::getItems();
        } else {
            return $this->___callPlugins('getItems', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getColumnValues($colName)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getColumnValues');
        if (!$pluginInfo) {
            return parent::getColumnValues($colName);
        } else {
            return $this->___callPlugins('getColumnValues', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getItemsByColumnValue($column, $value)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getItemsByColumnValue');
        if (!$pluginInfo) {
            return parent::getItemsByColumnValue($column, $value);
        } else {
            return $this->___callPlugins('getItemsByColumnValue', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getItemByColumnValue($column, $value)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getItemByColumnValue');
        if (!$pluginInfo) {
            return parent::getItemByColumnValue($column, $value);
        } else {
            return $this->___callPlugins('getItemByColumnValue', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function addItem(\Magento\Framework\DataObject $item)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'addItem');
        if (!$pluginInfo) {
            return parent::addItem($item);
        } else {
            return $this->___callPlugins('addItem', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function removeItemByKey($key)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'removeItemByKey');
        if (!$pluginInfo) {
            return parent::removeItemByKey($key);
        } else {
            return $this->___callPlugins('removeItemByKey', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function removeAllItems()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'removeAllItems');
        if (!$pluginInfo) {
            return parent::removeAllItems();
        } else {
            return $this->___callPlugins('removeAllItems', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function clear()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'clear');
        if (!$pluginInfo) {
            return parent::clear();
        } else {
            return $this->___callPlugins('clear', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function walk($callback, array $args = array())
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'walk');
        if (!$pluginInfo) {
            return parent::walk($callback, $args);
        } else {
            return $this->___callPlugins('walk', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function each($objMethod, $args = array())
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'each');
        if (!$pluginInfo) {
            return parent::each($objMethod, $args);
        } else {
            return $this->___callPlugins('each', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setDataToAll($key, $value = null)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setDataToAll');
        if (!$pluginInfo) {
            return parent::setDataToAll($key, $value);
        } else {
            return $this->___callPlugins('setDataToAll', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setCurPage($page)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setCurPage');
        if (!$pluginInfo) {
            return parent::setCurPage($page);
        } else {
            return $this->___callPlugins('setCurPage', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setPageSize($size)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setPageSize');
        if (!$pluginInfo) {
            return parent::setPageSize($size);
        } else {
            return $this->___callPlugins('setPageSize', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setItemObjectClass($className)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setItemObjectClass');
        if (!$pluginInfo) {
            return parent::setItemObjectClass($className);
        } else {
            return $this->___callPlugins('setItemObjectClass', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getNewEmptyItem()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getNewEmptyItem');
        if (!$pluginInfo) {
            return parent::getNewEmptyItem();
        } else {
            return $this->___callPlugins('getNewEmptyItem', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function toXml()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'toXml');
        if (!$pluginInfo) {
            return parent::toXml();
        } else {
            return $this->___callPlugins('toXml', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function toArray($arrRequiredFields = array())
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'toArray');
        if (!$pluginInfo) {
            return parent::toArray($arrRequiredFields);
        } else {
            return $this->___callPlugins('toArray', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function toOptionArray()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'toOptionArray');
        if (!$pluginInfo) {
            return parent::toOptionArray();
        } else {
            return $this->___callPlugins('toOptionArray', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function toOptionHash()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'toOptionHash');
        if (!$pluginInfo) {
            return parent::toOptionHash();
        } else {
            return $this->___callPlugins('toOptionHash', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getItemById($idValue)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getItemById');
        if (!$pluginInfo) {
            return parent::getItemById($idValue);
        } else {
            return $this->___callPlugins('getItemById', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getIterator()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getIterator');
        if (!$pluginInfo) {
            return parent::getIterator();
        } else {
            return $this->___callPlugins('getIterator', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function count()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'count');
        if (!$pluginInfo) {
            return parent::count();
        } else {
            return $this->___callPlugins('count', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getFlag($flag)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getFlag');
        if (!$pluginInfo) {
            return parent::getFlag($flag);
        } else {
            return $this->___callPlugins('getFlag', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function setFlag($flag, $value = null)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'setFlag');
        if (!$pluginInfo) {
            return parent::setFlag($flag, $value);
        } else {
            return $this->___callPlugins('setFlag', func_get_args(), $pluginInfo);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function hasFlag($flag)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'hasFlag');
        if (!$pluginInfo) {
            return parent::hasFlag($flag);
        } else {
            return $this->___callPlugins('hasFlag', func_get_args(), $pluginInfo);
        }
    }
}
