<?php
namespace Magento\Sales\Api\Data;

/**
 * Extension class for @see \Magento\Sales\Api\Data\OrderInterface
 */
class OrderExtension extends \Magento\Framework\Api\AbstractSimpleObject implements OrderExtensionInterface
{
    /**
     * @return \Magento\Sales\Api\Data\ShippingAssignmentInterface[]|null
     */
    public function getShippingAssignments()
    {
        return $this->_get('shipping_assignments');
    }

    /**
     * @param \Magento\Sales\Api\Data\ShippingAssignmentInterface[] $shippingAssignments
     * @return $this
     */
    public function setShippingAssignments($shippingAssignments)
    {
        $this->setData('shipping_assignments', $shippingAssignments);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getAmdeliverydateDate()
    {
        return $this->_get('amdeliverydate_date');
    }

    /**
     * @param string $amdeliverydateDate
     * @return $this
     */
    public function setAmdeliverydateDate($amdeliverydateDate)
    {
        $this->setData('amdeliverydate_date', $amdeliverydateDate);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getAmdeliverydateTime()
    {
        return $this->_get('amdeliverydate_time');
    }

    /**
     * @param string $amdeliverydateTime
     * @return $this
     */
    public function setAmdeliverydateTime($amdeliverydateTime)
    {
        $this->setData('amdeliverydate_time', $amdeliverydateTime);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getAmdeliverydateComment()
    {
        return $this->_get('amdeliverydate_comment');
    }

    /**
     * @param string $amdeliverydateComment
     * @return $this
     */
    public function setAmdeliverydateComment($amdeliverydateComment)
    {
        $this->setData('amdeliverydate_comment', $amdeliverydateComment);
        return $this;
    }

    /**
     * @return \Amasty\Orderattr\Api\Data\OrderAttributeDataInterface[]|null
     */
    public function getAmastyOrderAttributes()
    {
        return $this->_get('amasty_order_attributes');
    }

    /**
     * @param \Amasty\Orderattr\Api\Data\OrderAttributeDataInterface[] $amastyOrderAttributes
     * @return $this
     */
    public function setAmastyOrderAttributes($amastyOrderAttributes)
    {
        $this->setData('amasty_order_attributes', $amastyOrderAttributes);
        return $this;
    }

    /**
     * @return \Magento\GiftMessage\Api\Data\MessageInterface|null
     */
    public function getGiftMessage()
    {
        return $this->_get('gift_message');
    }

    /**
     * @param \Magento\GiftMessage\Api\Data\MessageInterface $giftMessage
     * @return $this
     */
    public function setGiftMessage(\Magento\GiftMessage\Api\Data\MessageInterface $giftMessage)
    {
        $this->setData('gift_message', $giftMessage);
        return $this;
    }

    /**
     * @return \Magento\Tax\Api\Data\OrderTaxDetailsAppliedTaxInterface[]|null
     */
    public function getAppliedTaxes()
    {
        return $this->_get('applied_taxes');
    }

    /**
     * @param \Magento\Tax\Api\Data\OrderTaxDetailsAppliedTaxInterface[] $appliedTaxes
     * @return $this
     */
    public function setAppliedTaxes($appliedTaxes)
    {
        $this->setData('applied_taxes', $appliedTaxes);
        return $this;
    }

    /**
     * @return \Magento\Tax\Api\Data\OrderTaxDetailsItemInterface[]|null
     */
    public function getItemAppliedTaxes()
    {
        return $this->_get('item_applied_taxes');
    }

    /**
     * @param \Magento\Tax\Api\Data\OrderTaxDetailsItemInterface[] $itemAppliedTaxes
     * @return $this
     */
    public function setItemAppliedTaxes($itemAppliedTaxes)
    {
        $this->setData('item_applied_taxes', $itemAppliedTaxes);
        return $this;
    }

    /**
     * @return boolean|null
     */
    public function getConvertingFromQuote()
    {
        return $this->_get('converting_from_quote');
    }

    /**
     * @param boolean $convertingFromQuote
     * @return $this
     */
    public function setConvertingFromQuote($convertingFromQuote)
    {
        $this->setData('converting_from_quote', $convertingFromQuote);
        return $this;
    }
}
